gtk-0.12.5.0: Binding to the Gtk+ graphical user interface library.

Portability | portable (depends on GHC)
Stability | provisional
Maintainer | gtk2hs-users@lists.sourceforge.net
Safe Haskell | None

Graphics.UI.Gtk.ActionMenuToolbar.Action

Contents

- Detail
- Class Hierarchy
- Types
- Constructors
- Methods
- Attributes
- Signals
- Deprecated

Description

An action which can be triggered by a menu or toolbar item

- Module available since Gtk+ version 2.4

Synopsis

- data Action
- class GObjectClass o => ActionClass o
- castToAction :: GObjectClass obj => obj -> Action
- gTypeAction :: GType
- toAction :: ActionClass o => o -> Action
- actionNew :: String -> String -> Maybe String -> Maybe StockId -> IO Action
- actionGetName :: ActionClass self => self -> IO String
- actionIsSensitive :: ActionClass self => self -> IO Bool
- actionGetSensitive :: ActionClass self => self -> IO Bool
- actionSetSensitive :: ActionClass self => self -> Bool -> IO ()
- actionIsVisible :: ActionClass self => self -> IO Bool
- actionGetVisible :: ActionClass self => self -> IO Bool
- actionSetVisible :: ActionClass self => self -> Bool -> IO ()
- actionActivate :: ActionClass self => self -> IO ()
- actionCreateMenuItem :: ActionClass self => self -> IO Widget
- actionCreateToolItem :: ActionClass self => self -> IO Widget
- actionConnectProxy :: (ActionClass self, WidgetClass proxy) => self -> proxy -> IO ()
- actionDisconnectProxy :: (ActionClass self, WidgetClass proxy) => self -> proxy -> IO ()
- actionGetProxies :: ActionClass self => self -> IO [Widget]
- actionConnectAccelerator :: ActionClass self => self -> IO ()
- actionDisconnectAccelerator :: ActionClass self => self -> IO ()
- actionGetAccelPath :: ActionClass self => self -> IO (Maybe String)
- actionSetAccelPath :: ActionClass self => self -> String -> IO ()
- actionSetAccelGroup :: ActionClass self => self -> AccelGroup -> IO ()
- actionName :: ActionClass self => Attr self String
- actionLabel :: ActionClass self => Attr self String
- actionShortLabel :: ActionClass self => Attr self String
- actionTooltip :: ActionClass self => Attr self (Maybe String)
- actionStockId :: ActionClass self => Attr self (Maybe String)
- actionVisibleHorizontal :: ActionClass self => Attr self Bool
- actionVisibleOverflown :: ActionClass self => Attr self Bool
- actionVisibleVertical :: ActionClass self => Attr self Bool
- actionIsImportant :: ActionClass self => Attr self Bool
- actionHideIfEmpty :: ActionClass self => Attr self Bool
- actionSensitive :: ActionClass self => Attr self Bool
- actionVisible :: ActionClass self => Attr self Bool
- actionAccelPath :: ActionClass self => ReadWriteAttr self (Maybe String) String
- actionAlwaysShowImage :: ActionClass self => Attr self Bool
- actionActivated :: ActionClass self => Signal self (IO ())
- onActionActivate :: ActionClass self => self -> IO () -> IO (ConnectId self)
- afterActionActivate :: ActionClass self => self -> IO () -> IO (ConnectId self)

# Detail

Actions represent operations that the user can be perform, along with some information how it should be presented in the interface. Each action provides methods to create icons, menu items and toolbar items representing itself.

As well as the callback that is called when the action gets activated, the following also gets associated with the action:

- a name (not translated, for path lookup)
- a label (translated, for display)
- an accelerator
- whether label indicates a stock id
- a tooltip (optional, translated)
- a toolbar label (optional, shorter than label)

The action will also have some state information:

- visible (shown/hidden)
- sensitive (enabled/disabled)

Apart from regular actions, there are toggle actions, which can be toggled between two states and radio actions, of which only one in a group can be in the "active" state. Other actions can be implemented as `Action` subclasses.

Each action can have one or more proxy menu item, toolbar button or other proxy widgets. Proxies mirror the state of the action (text label, tooltip, icon, visible, sensitive, etc), and should change when the action's state changes. When the proxy is activated, it should activate its action.

# Class Hierarchy

     | GObject
     | +----Action
     | +----ToggleAction

# Types

data Action

Instances

Eq Action |
Ord Action |
GObjectClass Action |
ActionClass Action |

class GObjectClass o => ActionClass o

Instances

ActionClass RadioAction |
ActionClass ToggleAction |
ActionClass RecentAction |
ActionClass Action |

castToAction :: GObjectClass obj => obj -> Action

gTypeAction :: GType

toAction :: ActionClass o => o -> Action

# Constructors

actionNew

Arguments

:: String | `name` - A unique name for the action
-> String | `label` - the label displayed in menu items and on buttons
-> Maybe String | `tooltip` - a tooltip for the action
-> Maybe StockId | `stockId` - the stock icon to display in widgets representing the action
-> IO Action |

Creates a new `Action` object. To add the action to a `ActionGroup` and set the accelerator for the action, call `actionGroupAddActionWithAccel`. See Graphics.UI.Gtk.ActionMenuToolbar.UIManager for information on allowed action names.

# Methods

actionGetName :: ActionClass self => self -> IO String

Returns the name of the action.

actionIsSensitive

Arguments

:: ActionClass self |
=> self |
-> IO Bool | returns `True` if the action and its associated action group are both sensitive.

Returns whether the action is effectively sensitive.

actionGetSensitive

Arguments

:: ActionClass self |
=> self |
-> IO Bool | returns `True` if the action itself is sensitive.

Returns whether the action itself is sensitive. Note that this doesn't necessarily mean effective sensitivity. See `actionIsSensitive` for that.

actionSetSensitive

Arguments

:: ActionClass self |
=> self |
-> Bool | `sensitive` - `True` to make the action sensitive
-> IO () |

Sets the sensitive property of the action to `sensitive`. Note that this doesn't necessarily mean effective sensitivity. See `actionIsSensitive` for that.

- Available since Gtk+ version 2.6

actionIsVisible

Arguments

:: ActionClass self |
=> self |
-> IO Bool | returns `True` if the action and its associated action group are both visible.

Returns whether the action is effectively visible.

actionGetVisible

Arguments

:: ActionClass self |
=> self |
-> IO Bool | returns `True` if the action itself is visible.

Returns whether the action itself is visible. Note that this doesn't necessarily mean effective visibility. See `actionIsSensitive` for that.

actionSetVisible

Arguments

:: ActionClass self |
=> self |
-> Bool | `visible` - `True` to make the action visible
-> IO () |

Sets the visible property of the action to `visible`. Note that this doesn't necessarily mean effective visibility. See `actionIsVisible` for that.

- Available since Gtk+ version 2.6

actionActivate :: ActionClass self => self -> IO ()

Emits the "activate" signal on the specified action, if it isn't insensitive. This gets called by the proxy widgets when they get activated.

It can also be used to manually activate an action.

actionCreateMenuItem

Arguments

:: ActionClass self |
=> self |
-> IO Widget | returns a menu item connected to the action.

Creates a menu item widget that proxies for the given action.

actionCreateToolItem

Arguments

:: ActionClass self |
=> self |
-> IO Widget | returns a toolbar item connected to the action.

Creates a toolbar item widget that proxies for the given action.

actionConnectProxy

Arguments

:: (ActionClass self, WidgetClass proxy) |
=> self |
-> proxy | `proxy` - the proxy widget
-> IO () |

Connects a widget to an action object as a proxy. Synchronises various properties of the action with the widget (such as label text, icon, tooltip, etc), and attaches a callback so that the action gets activated when the proxy widget does.

If the widget is already connected to an action, it is disconnected first.

Removed in Gtk3.

actionDisconnectProxy

Arguments

:: (ActionClass self, WidgetClass proxy) |
=> self |
-> proxy | `proxy` - the proxy widget
-> IO () |

Disconnects a proxy widget from an action.

Removed in Gtk3.

actionGetProxies :: ActionClass self => self -> IO [Widget]

Returns the proxy widgets for an action.

actionConnectAccelerator :: ActionClass self => self -> IO ()

Installs the accelerator for `action` if `action` has an accel path and group. See `actionSetAccelPath` and `actionSetAccelGroup`

Since multiple proxies may independently trigger the installation of the accelerator, the `action` counts the number of times this function has been called and doesn't remove the accelerator until `actionDisconnectAccelerator` has been called as many times.

actionDisconnectAccelerator :: ActionClass self => self -> IO ()

Undoes the effect of one call to `actionConnectAccelerator`.

actionGetAccelPath

Arguments

:: ActionClass self |
=> self |
-> IO (Maybe String) | returns the accel path for this action, or `Nothing` if none is set.

Returns the accel path for this action.

- Available since Gtk+ version 2.6

actionSetAccelPath

Arguments

:: ActionClass self |
=> self |
-> String | `accelPath` - the accelerator path
-> IO () |

Sets the accel path for this action. All proxy widgets associated with the action will have this accel path, so that their accelerators are consistent.

actionSetAccelGroup :: ActionClass self => self -> AccelGroup -> IO ()

Sets the `AccelGroup` in which the accelerator for this action will be installed.

# Attributes

actionName :: ActionClass self => Attr self String

A unique name for the action.

Default value: ""

actionLabel :: ActionClass self => Attr self String

The label used for menu items and buttons that activate this action.

Default value: ""

actionShortLabel :: ActionClass self => Attr self String

A shorter label that may be used on toolbar buttons.

Default value: ""

actionTooltip :: ActionClass self => Attr self (Maybe String)

A tooltip for this action.

Default value: `Nothing`

actionStockId :: ActionClass self => Attr self (Maybe String)

The stock icon displayed in widgets representing this action.

Default value: `Nothing`

actionVisibleHorizontal :: ActionClass self => Attr self Bool

Whether the toolbar item is visible when the toolbar is in a horizontal orientation.

Default value: `True`

actionVisibleOverflown :: ActionClass self => Attr self Bool

When `True`, toolitem proxies for this action are represented in the toolbar overflow menu.

Default value: `True`

- Available since Gtk+ version 2.6

actionVisibleVertical :: ActionClass self => Attr self Bool

Whether the toolbar item is visible when the toolbar is in a vertical orientation.

Default value: `True`

actionIsImportant :: ActionClass self => Attr self Bool

Whether the action is considered important. When `True`, toolitem proxies for this action show text in `ToolbarBothHoriz` mode.

Default value: `False`

actionHideIfEmpty :: ActionClass self => Attr self Bool

When `True`, empty menu proxies for this action are hidden.

Default value: `True`

actionSensitive :: ActionClass self => Attr self Bool

Whether the action is enabled.

Default value: `True`

- Available since Gtk+ version 2.6

actionVisible :: ActionClass self => Attr self Bool

Whether the action is visible.

Default value: `True`

- Available since Gtk+ version 2.6

actionAccelPath :: ActionClass self => ReadWriteAttr self (Maybe String) String

'accelPath' property. See `actionGetAccelPath` and `actionSetAccelPath`

- Available since Gtk+ version 2.6

actionAlwaysShowImage :: ActionClass self => Attr self Bool

If `True`, the action's menu item proxies will ignore the `menuImages` setting and always show their image, if available.

Use this property if the menu item would be useless or hard to use without their image.

Default value: `False`

Since 2.20

# Signals

actionActivated :: ActionClass self => Signal self (IO ())

The "activate" signal is emitted when the action is activated.

# Deprecated

onActionActivate :: ActionClass self => self -> IO () -> IO (ConnectId self)

The "activate" signal is emitted when the action is activated.

afterActionActivate :: ActionClass self => self -> IO () -> IO (ConnectId self)

The "activate" signal is emitted when the action is activated.